;flipem
;
;(c) 1986,  Jeff Beadles.  All rights reserved.
;
;    Flips the RLE picture 90 degrees for the print routines.
;			Version 1.0
;
;IF CALLED AS FLIPEM (D), THE IMAGE WILL BE DOUBLE-WIDE.
;
;
;
;
*LIST OFF
	ORG	3000H
*INCLUDE ASCII
LIST	EQU	@@1
	IF	LIST
*LIST ON
	ENDIF
INIT	DEFM	28,31,'Rle picture flippem program.',LF,14D
	DEFM	'(C) 1986,  Jeff Beadles.  All rights reserved.',LF,LF,LF
	DEFM	'Flippem is distributed as SHARE/FREE-WARE, and may NOT be'
	DEFM	' sold.  If you like',LF,'the program, PLEASE try and make a'
	DEFM	' contribution.',LF
	DEFM	'They may be sent to to me at',LF
	DEFM	LF,'Jeff Beadles'
	DEFM	LF,'POB 2208'
	DEFM	LF,'Florissant, MO.  63032',LF,LF
	DEFM	LF,LF,'Press <ENTER> to exit.  File MUST be in /HR (19k)'
	DEFM	' format.',LF
	DEFM	'Use FLIPPEM D to double-set the image (looks a lot better)',LF
	DB	CR
FNAM	DEFM	LF,'Enter filename: ',03D
READIN	DEFM	LF,'Reading file...',03D
READONE	DEFM	LF,'File read complete.  Converting file...',03D
KBUF	DS	80D
FCB	DS	32D
BUFF	DS	256D
ORGBUF	DS	19200D
NEWBUF	DS	19200D
BITS	DB	7D
YSAVE	DW	0
JEFF	LD	A,(HL)		;GET AN ARGUEMENT, IF ANY
	AND	5FH		;MAKE IT UPPER CASE
	CP	'D'		;DOUBLE?
	JR	NZ,JEFF1
	XOR	A
	LD	(PATCH),A	;PATCH THE RET TO A NOP
JEFF1	LD	HL,INIT
	LD	A,10		;@DISPLAY
	RST	28H
	LD	A,10
	LD	HL,FNAM
	RST	28H
	LD	A,9		;@KEYIN
	LD	HL,KBUF		;KEYBOARD BUFFER
	LD	B,79		;MAX CHARS
	LD	C,0		;DON'T ASK ME, IT JUST SAYS SO.
	RST	28H
	RET	NZ		;IF ERROR
	RET	C		;IF BREAK
	LD	A,B
	OR	A
	RET	Z		;IF BLANK LINE
	LD	A,(HL)
	LD	DE,FCB
	RST	28H
	LD	HL,KBUF		;LET'S USE THE FILENAME NOW
	LD	A,78		;@FSPEC
	RST	28H
	RET	NZ		;IF ERROR
	LD	A,59		;OPEN EXISTING FILE
	LD	HL,BUFF		;256BYTE DISK BUFFER
	LD	B,0		;LRL=256
	RST	28H
	JR	Z,FILOK		;IF THE FILE IS OK
	CP	2AH		;IS THERE A LRL ERROR?
	RET	NZ		;IF NOT, THEN WE HAVE A PROBLEM!
FILOK	LD	HL,READIN	;"READING FILE..."
	LD	A,10
	PUSH	DE
	RST	28H
	POP	DE
	LD	HL,ORGBUF	;THE ORIGINAL BUFFER
LOP	LD	A,3		;@GET A CHARACTER
	RST	28H
	JR	NZ,LOP1		;IF DONE (FINALLY!) ELSE
	LD	(HL),A		;SAVE THE CHAR IN THE ORIGBUF
	INC	HL		;BUMP TO THE NEXT POSITION
	JR	LOP
LOP1	LD	HL,READONE	;"FILE READ COMPLETE"
	LD	A,10
	RST	28H
	LD	DE,FCB
	LD	A,60		;@CLOSE
	RST	28H
FLIPIT	LD	HL,NEWBUF	;THE NEW BUFFER
	LD	BC,19199	;# OF BYTES-1
	XOR	A
	LD	(HL),A		;I'LL DO THE FIRST, YOU DO THE OTHER 19199!
	LD	DE,NEWBUF+1
	LDIR			;ZERO THE NEW BUFFER
	LD	A,7
	LD	(BITS),A	;START WORKING WITH BIT 7
	LD	H,30		;BYTES/LINE
	LD	C,0		;TO KEEP TRACK OF # OF LINES
	LD	IY,NEWBUF+19200-80	;LOWER LEFT CORNER
	LD	IX,ORGBUF	;UPPER RIGHT CORNER
	LD	(YSAVE),IY
LOOP2	LD	DE,-80		;** THIS LOOP FLIPS 1 SOURCE BYTE
	LD	B,8
	LD	A,(IX)
LOOP	RLA
	CALL	C,SETB		;IF THERE'S A BIT TO SET
SKIP	ADD	IY,DE		;MOVE TO THE NEXT DEST. BYTE
	DJNZ	LOOP		;NEXT BIT PLEASE...  **  END OF THE 1 BYTE LOOP
	INC	IX		;MOVE TO THE NEXT SOURCE BYTE AFTER 8 BITS
	DEC	H		;TIME FOR THE NEXT BYTE
	JR	NZ,LOOP2
	LD	H,30D		;** AN ENTIRE ROW DONE, SO 
	INC	C		;BUMP THE POINTERS TO THE NEXT SOURCE ROW
	LD	A,C
	CP	240D		;FIRST, ARE WE DONE?
	JR	Z,DONE
	LD	IX,ORGBUF	;IF NOT, IT'S TIME TO GO TO THE
	LD	DE,80		;NEXT ROW OF SOURCE BYTES
	PUSH	BC
	LD	B,C
CONTA	ADD	IX,DE		;RACK-EM UP
	DJNZ	CONTA
	POP	BC
	LD	IY,(YSAVE)
	LD	A,(PATCH)
	OR	A
	JR	Z,DOUBLE	;IF DOUBLE STEPPING
	LD	A,(BITS)	;ARE WE READY FOR THE NEXT DEST. COLUMN
	DEC	A
	AND	7
	LD	(BITS),A
	CP	7
	JR	NZ,LOOP2
CONTC	INC	IY
	LD	(YSAVE),IY
	JR	LOOP2
DOUBLE	LD	A,(BITS)
	DEC	A
	DEC	A
	AND	7
	LD	(BITS),A
	CP	6
	JR	Z,CONTC
	CP	7
	JR	Z,CONTC
	JR	LOOP2
SETB	PUSH	AF
	LD	A,(BITS)	;GET THE BIT TO SET (0..7)
	CALL	SETBIT		;SET A,(IY)
	POP	AF
PATCH	RET			;MAY BE PATCHED TO A NOP IF DOUBLE SETTING
	PUSH	AF
	LD	A,(BITS)
	INC	A
	AND	7
	CP	7
	JR	Z,SETNEXT	;SET THE NEXT BYTE
	CALL	SETBIT
	POP	AF
	RET
SETNEXT	INC	IY
	CALL	SETBIT
	DEC	IY
	POP	AF
	RET
SETBIT	RLA
	RLA
	RLA
	AND	00111000B
	OR	11000110B	;SELF MODIFIN' CODE...  AIN'T IT GRAND
	LD	(DOIT),A	;SAVE THE THING
	DB	0FDH		;SET COMMAND
	DB	0CBH
	DB	0
DOIT	DB	11000110B	;WHERE THE MOD'ED CODE WILL BE PUT FOR A
	RET
DONE	LD	HL,FNAM
	LD	A,10
	RST	28H
	LD	A,9		;@KEYIN
	LD	HL,KBUF		;KEYBOARD BUFFER
	LD	B,79		;MAX CHARS
	LD	C,0		;DON'T ASK ME, IT JUST SAYS SO.
	RST	28H
	RET	NZ		;IF ERROR
	RET	C		;IF BREAK
	LD	A,B
	OR	A
	RET	Z		;IF BLANK LINE
	LD	DE,FCB
	LD	HL,KBUF		;LET'S USE THE FILENAME NOW
	LD	A,78		;@FSPEC
	RST	28H
	RET	NZ		;IF ERROR
	LD	A,58		;INIT FILE
	LD	HL,BUFF		;256BYTE DISK BUFFER
	LD	B,0		;LRL=256
	RST	28H
	JR	Z,PUTOK		;IF THE FILE IS OK
	CP	2AH		;IS THERE A LRL ERROR?
	RET	NZ		;IF NOT, THEN WE HAVE A PROBLEM!
PUTOK	LD	HL,NEWBUF-1
	LD	BC,19201
PUTZ	DEC	BC
	LD	A,B
	OR	C
	JR	Z,DDONE
	INC	HL
	LD	A,(HL)
	PUSH	BC
	LD	C,A
	LD	A,4		;@PUTZ
	RST	28H
	RET	NZ		;IF ERR
	POP	BC
	JR	PUTZ
DDONE	LD	A,60
	RST	28H
	RET
	END	JEFF

